[Kotlin](https://kotlinlang.org) is an example of a modern programming language. Designed by [JetBrains](https://www.jetbrains.com) in 2011, Kotlin includes language features to make safe, concurrent, multi-platform programming easier. Kotlin is intended to be a drop-in replacement for Java, and has full interoperability with Java source code and libraries. You can mix Java and Kotlin code, and still leverage all of the capabilities of the Java ecosystem.

Kotlin has a number of language features that make it desireable for building applications:

- It has a very **clean syntax**, and support quality-of-life features like default arguments, and variable arg lists. It closely resembles modern languages like Swift or Scala.
- It's a **hybrid language**: it can be used for declarative programming or class-based object-oriented programming. It also supports a number of functional features, especially in the use of collection classes. This allows a programmer to use the best appropach for a particular task.
- Kotlin is **statically compiled**, so it catches many potential errors during compilation (not just at runtime). It's also strongly typed, with type inference.
- It handles **NULL data** exceptionally well, preventing many common errors that can occur (and simplifying error handling).
- Kotlin has excellent async support using **coroutines** (basically lightweight threads). This is really helpful when building scalable services.

